// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3)
// Source File Name:   TileSlicer.java

import java.awt.image.BufferedImage;
import java.io.*;
import java.util.ArrayList;
import java.util.ListIterator;
import javax.imageio.ImageIO;

public class TileSlicer
{

    public TileSlicer()
    {
    }

    public static void main(String args[])
        throws IOException
    {
        if(args.length > 0)
            map = ImageIO.read(new File(args[0]));
        else
            map = ImageIO.read(new File("map.png"));
        
        if(args.length > 1)
            tileWidth = Integer.parseInt(args[1]);
        else
            tileWidth = 16;

        if(args.length > 2)
            tileHeight = Integer.parseInt(args[2]);
        else
            tileHeight = tileWidth;

        tiles = new ArrayList();
        tileMap = new int[map.getWidth() / tileWidth][map.getHeight() / tileHeight];
        if(map.getWidth() % tileWidth != 0 || map.getHeight() % tileHeight != 0)
        {
            System.out.println("ERROR: Image dimensions not a multiple of the tile size");
            return;
        } else
        {
            slice();
            writeToFiles();
            return;
        }
    }

    private static void slice()
    {
        for(int y = 0; y < map.getHeight(); y += tileHeight)
        {
            for(int x = 0; x < map.getWidth(); x += tileWidth)
            {
                BufferedImage tempTile = map.getSubimage(x, y, tileWidth, tileHeight);
                boolean found = false;
                ListIterator iter = tiles.listIterator();
                do
                {
                    if(!iter.hasNext())
                        break;
                    if(tilesAreEqual(tempTile, (BufferedImage)iter.next()))
                    {
                        tileMap[x / tileWidth][y / tileHeight] = iter.previousIndex();
                        found = true;
                    }
                } while(true);
                if(!found)
                {
                    tiles.add(tempTile);
                    tileMap[x / tileWidth][y / tileHeight] = tiles.size() - 1;
                }
            }

        }

    }

    private static void writeToFiles()
        throws IOException
    {
        for(int i = 0; i < tiles.size(); i++)
            ImageIO.write((BufferedImage)tiles.get(i), "png", new File(i + ".png"));

        FileWriter out = new FileWriter("map.txt");
        FileWriter html = new FileWriter("map.html");
        out.write("Dimensions: " + tileMap.length + " x " + tileMap[0].length + "\nUnique tiles: " + tiles.size() + "\n\nMap Data:\n");
        html.write("<html><head><title>Map</title></head>\n<body>Dimensions: " + tileMap.length + "&times;" + tileMap[0].length + "<br>Unique tiles: " + tiles.size() + "<br><br>Map Data:<br><nobr>\n");
        for(int y = 0; y < tileMap[0].length; y++)
        {
            for(int x = 0; x < tileMap.length; x++)
            {
                out.write(tileMap[x][y] + " ");
                html.write("<img src=\""+tileMap[x][y] + ".png\">");
            }

            out.write("\n");
            html.write("<br>\n");
        }

        html.write("</nobr></body></html>");
        out.close();
        html.close();
    }

    private static boolean tilesAreEqual(BufferedImage a, BufferedImage b)
    {
        for(int y = 0; y < tileHeight; y++)
        {
            for(int x = 0; x < tileWidth; x++)
                if(a.getRGB(x, y) != b.getRGB(x, y))
                    return false;

        }

        return true;
    }

    private static BufferedImage map;
    private static ArrayList tiles;
    private static int tileMap[][];
    private static int tileWidth;
    private static int tileHeight;
    private static final String DEFAULT_FILE = "map.png";
}
